/*
	All Master Receive and Txmit routines are here
	Weights and cards are passed to main prog via shared memory
*/
#include <stdio.h>
#include <fcntl.h>
#include <termio.h>
#include <sys/types.h>
#include <time.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define		RBUFSIZ		32		/* size of the receiver buffer	*/
#define		MAX_RDR		16

/*
	external memory defines
*/
static int fstrdr;

char *datadir = "/u/data/";		/* data directory		*/
char *slfiln = "gbloop";		/* error log file name	*/

extern char *cardUSBRead(int rdr);

/*
	Shared mem stuff
*/
extern int errno;

struct shmid_ds shmdat;
static char *shmstr;
static char ipaddress[64];

main(int argc, char *argv[])
{
	int delay, rdr, shmid;
	char buf[80];

	if (argc < 3)
	{
		printf("Usage: crloop [device] [ip address]\n");
		printf(" where device is 1 for receiving scale 2 for dump station\n");
		exit(1);
	}
	fstrdr = 1;
	rdr = atoi(argv[1]);
	if (rdr < 1 || rdr > 2)
	{
		printf("Only readers 1 & 2 are supported\n");
		exit(1);
	}
	strcpy(ipaddress, argv[2]);
	
	if ((shmid = shmget((key_t)30101, MAX_RDR * 32, 0666)) == -1)
	{
		if ((shmid = shmget((key_t)30101, MAX_RDR * 32, IPC_CREAT | 0666)) == -1)
		{
			printf("Error Code %d from shmget()\n", errno);
			cerror("Error from shmget");
			exit(2);
		}
	}

	if (! (shmstr = shmat(shmid, NULL, 0)))
	{
		printf("Error Code %d from shmat()\n", errno);
		cerror("Error from shmat()");
		exit(3);
	}
//	if (! cardUSBConnect(0, 23, "192.0.0.202"))
	if (! cardUSBConnect(rdr - fstrdr, 23, ipaddress))	// "192.0.0.108"))
	{
		printf("Failed to connect to dump station card reader %d addr %s\n", rdr, ipaddress);
		cerror("Failed to connect to dump station card reader");
		exit(4);
	}
	sprintf(buf, "Monitoring IP %s Reader %d", ipaddress, rdr);
	printf("%s\n", buf);
	cerror(buf);

	delay = 0;
	while (1)
	{
		getcrd(rdr);
		nap(343);
		if (++delay > 1800)	// about 10 minutes
		{
			cardUSBDisconnect(rdr - fstrdr);
			if (! cardUSBConnect(rdr - fstrdr, 23, ipaddress))
			{
				sprintf(buf, "Card Addr %d failed to connect", rdr);
				cerror(buf);
				break;
			}
			delay = 0;
		}
	}
/* won't ever get here
	if (shmdt(shmstr))
	{
		cerror("Error from shmdt()");
		printf("Error Code %d from shmdt()\n", errno);
		exit(0);
	}
*/
}

getcrd(int rdr)
{
	char *card;

	card = cardUSBRead(rdr - fstrdr);
	if (card)
		strcpy(shmstr + (rdr - fstrdr) * 32, card);
}

cerror(char *s)
{
	char fn[64];
	int fd;

	strcpy(fn, datadir);
	strcat(fn, slfiln);
	strcat(fn, ".log");
	fd = open(fn, O_WRONLY | O_CREAT | O_APPEND, 0660);
	if (fd != -1)
	{
		gettmdt(fn);
		write(fd, fn, strlen(fn) - 1);	
		write(fd, " ", 1);	
		write(fd, s, strlen(s));
		write(fd, "\n", 1);
		close(fd);
	}
}

gettmdt(char *s)
{
	struct tm *tmstr;
	long ltime;

	time(&ltime);
	tmstr = localtime(&ltime);
	strcpy(s, asctime(tmstr));
}

